/*
 * OZ711MS1 OZ711MP1 linux driver
 * O2Micro Inc.
 * toby.yang@o2micro.com
 * 2005/4/17
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/****************************************************************************
 * O2Micro, Inc. presidio device driver for Linux.
 *
 *
 * Revisions 0.1 
 * toby.yang@o2micro.com
 * 2004/07/27
 ****************************************************************************/
#ifndef _BASE_H
#define _BASE_H



#define DRIVER_NAME "presidio"

#ifndef LINUX_VERSION_CODE
#include <linux/version.h>
#endif 
#define	LINUXVERSION(v,p,s)    (((v)<<16) + ((p)<<8) + (s))

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
#ifndef MODULE
#define MODULE
#endif
#endif

#define PCI_PORT_ADDRESS             0xcf8
#define PCI_PORT_DATA                0xcfc

#define VENDOR_O2MICRO		0x1217
#define DEVICE_PRESIDIO_F0	0x7134
#define DEVICE_PRESIDIO_F2	0x7120
#define DEVICE_PRESIDIO_F3	0x7130

#include <asm/io.h>
#include <asm/uaccess.h>
#include <asm/page.h>
#include <asm/byteorder.h>
#include <linux/stddef.h>
#include <linux/string.h>
#include <linux/errno.h>
#include <linux/kernel.h>
#include <linux/ioport.h>
#include <linux/slab.h>
#include <linux/delay.h>
#include <linux/pci.h>
#include <linux/proc_fs.h>
#include <linux/reboot.h>
#include <linux/interrupt.h>
#include <linux/types.h>
#include <scsi/sg.h>
#include <linux/stat.h>
#include <linux/config.h>

#include <linux/spinlock.h>
#include <linux/sched.h>
#include <linux/smp_lock.h>
#include <asm/semaphore.h>
#include <linux/completion.h>
#include <linux/delay.h>
#include <linux/kdev_t.h>
#include <asm/system.h>
#include <linux/devfs_fs_kernel.h>
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
#else
#include <linux/wait.h>
#endif
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
#include <linux/blk.h>
#include "scsi.h"
#include "hosts.h"
#else
#include <scsi/scsi_host.h>
#include <scsi/scsi_cmnd.h>
#include <scsi/scsi_device.h>
#include <scsi/scsi.h>
#endif

#define _PCI_CONTEXT struct pci_dev*

#include "basic.h"
extern ULONG o2sd_base;
extern UCHAR o2sd_irq;
extern ULONG o2media_base;
extern UCHAR o2media_irq;
#define PRESIDIO_DEBUG
#undef PDEBUG
#ifdef PRESIDIO_DEBUG
#define PDEBUG(fmt,args...) printk(KERN_ERR "presidio: " fmt "\n" , ## args)
#else
#define PDEBUG(fmt,args...)
#endif
#endif
