/* sdio.h */       


#ifndef _SDIO_H_
#define _SDIO_H_
#include "winif2.h"
#include "base.h"
#define SD_CMD00		0x00000000
#define SD_CMD02		0x02090000
#define SD_CMD03		0x031A0000
#define SD_CMD04		0x04000000
#define SD_CMD07		0x071B0000
#define SD_CMD09		0x09090000
#define SD_CMD10		0x0A090000
#define SD_CMD12		0x0CDB0000
#define SD_CMD13		0x0D1A0000
#define SD_CMD15		0x0F000000
#define SD_CMD16		0x101A0000
#define SD_CMD17		0x113A0010
#define SD_CMD18		0x123A0036
#define SD_CMD24		0x183A0000
#define SD_CMD25		0x193A0026
#define SD_CMD27		0x1B3A0000
#define SD_CMD28		0x1C1B0000
#define SD_CMD29		0x1D1B0000
#define SD_CMD30		0x1E3A0000
#define SD_CMD32		0x201A0000
#define SD_CMD33		0x211A0000
#define SD_CMD38		0x261B0000
#define SD_CMD42		0x2A3A0000
#define SD_CMD55		0x371A0000
#define SD_CMD56R		0x381B0010
#define SD_CMD56W		0x381B0000

#define SD_ACMD06		0x061A0000
#define SD_ACMD13		0x0D3A0010
#define	SD_ACMD18	    0x121A0000
#define SD_ACMD22		0x163A0000
#define SD_ACMD23		0x171A0000
#define	SD_ACMD25	    0x191A0000
#define SD_ACMD41		0x29020000
#define SD_ACMD42		0x2A1A0000
#define	SD_ACMD43	    0x2b1A0000
#define	SD_ACMD44	    0x2c1A0000
#define SD_ACMD51		0x333A0010


/*-----  Command for MMC controler  --------------------------------------------------------------
------------------------------------------------------------------------------------------------*/
#define	MMC_CMD00		SD_CMD00
#define	MMC_CMD01		0x01020000
#define	MMC_CMD02		SD_CMD02
#define	MMC_CMD03		SD_CMD03
#define MMC_CMD04		SD_CMD04
#define	MMC_CMD07		SD_CMD07
#define	MMC_CMD09		SD_CMD09
#define	MMC_CMD10		SD_CMD10
#define MMC_CMD11		0x0B3A0010
#define	MMC_CMD12		SD_CMD12
#define	MMC_CMD13		SD_CMD13
#define MMC_CMD15		SD_CMD15
#define	MMC_CMD16		SD_CMD16
#define	MMC_CMD17		SD_CMD17
#define	MMC_CMD18		SD_CMD18
#define MMC_CMD20		0x143B0000
#define	MMC_CMD24		SD_CMD24
#define	MMC_CMD25		SD_CMD25
#define MMC_CMD26		0x1A3B0000
#define MMC_CMD27		0x1B3B0000
#define MMC_CMD28		SD_CMD28
#define MMC_CMD29		SD_CMD29
#define MMC_CMD30		SD_CMD30
#define MMC_CMD32		SD_CMD32
#define MMC_CMD33		SD_CMD33
#define MMC_CMD34		0x221A0000
#define MMC_CMD35		0x231A0000
#define MMC_CMD36		0x241A0000
#define MMC_CMD37		0x251A0000
#define MMC_CMD38		SD_CMD38
#define MMC_CMD42		0x2A3B0000
#define MMC_CMD56R		SD_CMD56R
#define MMC_CMD56W		SD_CMD56W


/*-----  Command for SDIO controler  -------------------------------------------------------------
------------------------------------------------------------------------------------------------*/
#define SDIO_CMD05		0x05020000
#define SDIO_CMD52		0x341A0000
#define SDIO_CMD53		0x353A0000   


#define SDIO_CMD_DATA_PRESENT 0x00100000
#define SDIO_CMD_TRANS_READ   0x00000010           

/*-----  Bit order of register(Host Control Reg)  ------------------------------------------------
------------------------------------------------------------------------------------------------*/
#define	SDIO_BUS_4		0x00000002
#define	SDIO_LED_ON		0x00000001

/*-----  Bit order of register(Power Control Reg)  -----------------------------------------------
------------------------------------------------------------------------------------------------*/
#define	SDIO_BUSVOLALL	0x00000e00
#define	SDIO_BUSVOL33	0x00000e00
#define	SDIO_BUSVOL30	0x00000c00
#define	SDIO_BUSVOL18	0x00000a00
#define	SDIO_BUSPOW_ON	0x00000100

/*-----  Bit order of register(Present State Reg)  -----------------------------------------------
------------------------------------------------------------------------------------------------*/
#define	SDIO_CMDSIG_LV	0x01000000
#define	SDIO_DATSIG_LV	0x00F00000
#define	SDIO_WRPRT_PIN	0x00080000
#define	SDIO_CDDET_PIN	0x00040000
#define	SDIO_CARD_STB	0x00020000
#define	SDIO_CARD_INS	0x00010000
#define	SDIO_BUF_RDE		0x00000800
#define	SDIO_BUF_WRE		0x00000400
#define	SDIO_RDT_ACT		0x00000200
#define	SDIO_WRT_ACT		0x00000100
#define	SDIO_DAT_ACT		0x00000004
#define	SDIO_DATINHI		0x00000002
#define	SDIO_CMDINHI		0x00000001


#define	SDIO_BCLK_DIVC	0xffff00ff
#define	SDIO_BCLK_DIV256	0x00008000
#define	SDIO_BCLK_DIV128	0x00004000
#define	SDIO_BCLK_DIV64	0x00002000
#define	SDIO_BCLK_DIV32	0x00001000
#define	SDIO_BCLK_DIV16	0x00000800
#define	SDIO_BCLK_DIV8	0x00000400
#define	SDIO_BCLK_DIV4	0x00000200
#define	SDIO_BCLK_DIV2	0x00000100
#define	SDIO_BCLK_DIV0	0x00000000
#define	SDIO_SDCLK_EN	0x00000004
#define	SDIO_OSC_STB		0x00000002
#define	SDIO_OSC_EN		0x00000001
                    
#define SDIO_ERR_INTST  0x00008000                    
#define SDIO_CARD_INTST	0x00000100
#define SDIO_CRMV_INTST	0x00000080
#define SDIO_CIST_INTST	0x00000040
#define SDIO_BFRR_INTST	0x00000020
#define SDIO_BFWR_INTST	0x00000010
#define SDIO_DMA_INTST	0x00000008
#define SDIO_BGAP_INTST	0x00000004
#define SDIO_TRNC_INTST	0x00000002
#define SDIO_CMDC_INTST	0x00000001

#define SDIO_CMDC_UNMASK	0x01
#define SDIO_BFRR_UNMASK	0x20
#define SDIO_BFWR_UNMASK	0x10
#define SDIO_TRNC_UNMASK	0x02
#define SDIO_TRNC_MASK		0xFFFFFFFD

struct sdio_phy_registers
{
	unsigned long OCR; 
	struct {
		unsigned char ManufacturingDate;
		unsigned long SerialNumber;
		char ProductName[6];
                unsigned char Revision;
		unsigned short ApplicationID;
		unsigned char ManufacturerID;
	} CID;
	
#ifdef MEMBER_ALIGN_OFF
	struct {
		unsigned short ECC:2;
		unsigned short FILE_FORMAT:2;
		unsigned short TEMP_PROTECT:1;
		unsigned short PERM_PROTECT:1;
		unsigned short COPY:1;
		unsigned short FIE_FORMAT_GRP:1;
		unsigned short Reserved0:5;
		unsigned short WRITE_BL_PARTIAL:1;
		unsigned short WRITE_BL_LEN:4;
		unsigned short R2W_FACTOR:3;
		unsigned short DEFAULT_ECC:2;
		unsigned short WP_GRP_ENABLE:1;
		unsigned short WP_GRP_SIZE:5;
		unsigned short ERASE_GRP_SIZE:5;
		unsigned short SECTOR_SIZE:5;
		unsigned short C_SIZE_MULT:3;
		unsigned short VDD_CURR:12;
		unsigned short C_SIZE:12;
		unsigned short Reserved1:2;
                unsigned short DSR_IMP:1;
		unsigned short READ_BL_MISALIAN:1;
		unsigned short WRITE_BL_MISALIAN:1;
		unsigned short READ_BL_PARTIAL:1;
		unsigned short READ_BL_LEN:4;
		unsigned short CCC:12;
		unsigned short TRAN_SPEED:8;
		unsigned short NSAC:8;
		unsigned short TAAC:8;
		unsigned short Reserved2:2;
		unsigned short SPEC_VERS:4;
		unsigned short CSD_STRUCTURE:2;
	} CSD;             
#else 
	char CSD[16];
#endif	
	unsigned short RCA;
	unsigned short DSR;
	unsigned long  STATUS;
	unsigned long  SCR;
};                                 

int sdio_send_command(unsigned long membase, unsigned long cmddata, unsigned long argument);
int sdio_send_Acommand(unsigned long membase, unsigned short RCA, unsigned long cmddata, unsigned long argument);
unsigned long sdio_get_status(unsigned long membase);
unsigned long sdio_get_interrupt(unsigned long membase);
unsigned long sdio_reset(unsigned long membase);                         

/* poweron 0, off, voltage select*/
unsigned long sdio_setpower(unsigned long membase, unsigned short poweron);

int sdio_phase_response(unsigned long membase, unsigned long cmddata);  

/* clocktype , 0 stop, 1, safe , 2 fastest */
int sdio_setclock(unsigned long membase, int clocktype);  

int sdio_wait_commandcomplete();
int sdio_wait_commandcomplete_2(unsigned long membase, EVENT* pEvent);
int sdio_wait_bufferready(unsigned long membase);
int sdio_wait_bufferready_3(unsigned long membase);
int sdio_wait_bufferready_4(unsigned long membase);

/*                                  
#define SDIO_RESPONSE_TYPE_ELLEN_NONE   0x00000000
#define SDIO_RESPONSE_TYPE_ELLEN_R2     0x00090000
#define SDIO_RESPONSE_TYPE_ELLEN_R3     0x00020000
#define SDIO_RESPONSE_TYPE_ELLEN_R4     0x00020000
#define SDIO_RESPONSE_TYPE_ELLEN_R1     0x001A0000
#define SDIO_RESPONSE_TYPE_ELLEN_R6     0x001A0000
#define SDIO_RESPONSE_TYPE_ELLEN_R5     0x001A0000
#define SDIO_RESPONSE_TYPE_ELLEN_R1b    0x001B0000
#define SDIO_RESPONSE_TYPE_ELLEN_R5b    0x001B0000
#define SDIO_RESPONSE_TYPE_MASK_ELLEN   0x001F0000
*/
#define SDIO_RESPONSE_TYPE_ELLEN_NONE   0x00000000
#define SDIO_RESPONSE_TYPE_ELLEN_STATUS 0x00000002
#define SDIO_RESPONSE_TYPE_ELLEN_CID    0x00000003
#define SDIO_RESPONSE_TYPE_ELLEN_CSD    0x00000004
#define SDIO_RESPONSE_TYPE_ELLEN_OCR    0x00000001
#define SDIO_RESPONSE_TYPE_ELLEN_RCA    0x00000005
#define SDIO_RESPONSE_TYPE_MASK_ELLEN   0x001F0000

#define SDIO_RESPONSE_CARD_POWERUP_FREE 0x80000000

                                
int sdio_response_pharse(unsigned long membase, struct sdio_phy_registers* r, unsigned long Type);


#endif /* !_SDIO_H_*/
