/*
 * OZ711MS1 OZ711MP1 linux driver
 * O2Micro Inc.
 * toby.yang@o2micro.com
 * 2005/4/17
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "base.h"
#include "scsi_base.h"
void set_pri_data(spinlock_t *lock,unsigned char* pri_data,unsigned char value)
{
	unsigned long flags;
	spin_lock_irqsave(lock,flags);
	*pri_data = value;
	spin_unlock_irqrestore(lock,flags);
}
void setscsiresult(struct scsi_cmnd *SCpnt,int ret)
{
		// 0 means GOOD
		// 1 means DID_ERROR<<16
		// 2 means CHECK_CONDITION
		// 3 means DID_OK<<16
	switch (ret) {
	case 0:
		SCpnt->result = GOOD;
		break;
	case 1:
		SCpnt->result = DID_ERROR << 16;
		break;
	case 2:
		SCpnt->result = CHECK_CONDITION;
		break;
	case 3: 
		SCpnt->result = DID_OK << 16;
		break;
	case 4:
		SCpnt->result = DID_NO_CONNECT << 16;
		break;
	}
}

void dumprequestbuffer(unsigned char* request_buf,int length)
{
	int i;
	printk("buf dump begin\n");
	for(i=0;i<(length/4);i++)
		printk("%x\n",*(unsigned long*)((unsigned long*)request_buf+i));
	printk("request_buf dump end\n");
}
void dumpbuffer(unsigned char* request_buf,int length)
{
	int i;
	printk("buf dump begin\n");
	for(i=0;i<(length/4);i++)
		printk("%x,",*(unsigned long*)((unsigned long*)request_buf+i));
	printk("buf dump end\n");
}
static unsigned char* mp1_map(struct page *mpage)
{
	return kmap(mpage);	
}
static void mp1_unmap(struct page *mpage)
{
	kunmap(mpage);

}

/*
	dir = 1, copy buffer to sg
	dir = 0, copy sg to buffer
*/
void mp1_xfer_buf(unsigned long sg_num,struct scatterlist *sg,unsigned char* buffer,unsigned long dir,unsigned long debug)
{
	int i;
	for (i = 0; i < sg_num; i++)
	{
					
		unsigned long poff = sg[i].offset;
		unsigned long sglen = sg[i].length;
		if(debug)
		{
			printk("sg_num = %d,poff=%x,sglength=%x\n",sg_num,poff,sglen);
		}
		struct page *mpage = sg[i].page;
		while(sglen>0)
		{	
			unsigned long plen = min(sglen,(unsigned long)PAGE_SIZE-poff);
			unsigned char* ptr = mp1_map(mpage);
			if(debug)
			{
				printk("mapptr=%x\n",ptr);	
			}
			if(dir == 1)// copy to sg
				memcpy(ptr+poff,buffer,plen);
			else// copy from sg to buffer
				memcpy(buffer,ptr+poff,plen);
			mp1_unmap(mpage);
			// start at the beginning of the next page
			poff = 0;
			++(mpage);
			buffer+=plen;
			sglen-=plen;
		}
	}
}
