/*
 * OZ711MS1 OZ711MP1 linux driver
 * O2Micro Inc.
 * toby.yang@o2micro.com
 * 2005/4/17
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _SCSI_O2SD_H_
#define _SCSI_O2SD_H_

#include "base.h"
#include "basic.h"
#include "scsi_base.h"
struct t_o2sd_pri_data {
int ko2sd_pid;	// the pid for thread using register/unregister when card insert/remove.
int ko2sd_cmd_control_pid; // pid of thread handling scsi command from system scsi layer.
struct scsi_cmnd* cur_srb; // current scsi srb.
struct completion notify;
unsigned long sdio_NeedCancel;
spinlock_t cmd_lock;
spinlock_t srb_lock;
spinlock_t cc_lock;
spinlock_t br_lock;
spinlock_t bw_lock;
spinlock_t tc_lock;
spinlock_t sdio_err_lock;
spinlock_t cardexist_lock;
unsigned char cardexist;
wait_queue_head_t o2sd_cmd_control_event;
unsigned char o2sd_cmd_comming;
wait_queue_head_t o2sd_cc_event;
unsigned char o2sd_cc;
wait_queue_head_t o2sd_br_event;
unsigned char o2sd_br;
wait_queue_head_t o2sd_bw_event;
unsigned char o2sd_bw;
wait_queue_head_t o2sd_tc_event;
unsigned char o2sd_tc;
unsigned char sdio_err;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
Scsi_Host_Template *po2sd_myht;
#else
struct Scsi_Host *o2sd_sh;
struct scsi_host_template *po2sd_myht;
#endif
unsigned char* buffer;
unsigned long buffer_size;
};
extern struct t_o2sd_pri_data o2sd_pri_data;

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
extern Scsi_Host_Template o2sd_host_template;
#else
extern struct scsi_host_template o2sd_host_template;
#endif
BOOLEAN o2sd_device_reset();
BOOLEAN o2sd_bus_reset();
void o2sd_preUnInit();
BOOLEAN o2sd_cmd_abort();
BOOLEAN o2sd_check_intr();
BOOLEAN o2sd_host_reset(unsigned long devext_addr);
int o2sd_inquiry(INQUIRY_DATA* inquiry,unsigned long devext_addr);
int o2sd_testunitready(unsigned long devext_addr);
int o2sd_requestsense(SENSE_DATA *senseBuffer,unsigned long devext_addr);
int o2sd_modesense(MODE_PAGE_DATA* mdata,BOOLEAN mdata_3f,unsigned long devext_addr);
int  o2sd_allowmediumremoval(ULONG devext_addr);
int o2sd_readcapacity(READ_CAPACITY_DATA* capacityData,ULONG devext_addr);
int	o2sd_readData(PUCHAR currentBuf,ULONG startBlock,ULONG blockCount,ULONG devext_addr);
int	o2sd_writeData(PUCHAR currentBuf,ULONG startBlock,ULONG blockCount,ULONG devext_addr);
BOOLEAN o2sd_SCIInitialize(ULONG m_o2sd_base,ULONG resume);
BOOLEAN o2sd_interrupt();
#endif
